# Minimum audacious/audacious-plugins version in inter-package
# dependencies. We have 1.5.1 for both, so we enforce 1.5.1.
%define aud_ver 1.5.1

Name:           audacious-plugins
Version:        1.5.1
Release:        19%{?dist}
Summary:        Plugins for the Audacious media player
Group:          Applications/Multimedia

# LGPLv2+: adplug, bio2jack, rocklight
# MIT: crystalizer, dockalbumart
# BSD: lastfm
License:        GPLv2 and GPLv2+ and LGPLv2+ and MIT and BSD

URL:            http://audacious-media-player.org/
# The original source files contain various codecs which clash
# with the FE license guidelines. They are removed in the -fedora-
# file.
# Source0: http://distfiles.atheme.org/audacious-plugins-%{version}.tgz
Source0:        audacious-plugins-fedora-%{version}.tar.gz
Source1:        audacious-plugins.desktop
Patch3:         audacious-plugins-1.5.1-libmtp.patch
Patch4:         audacious-plugins-1.5.1-vorbis-oga.patch
Patch5:         audacious-plugins-1.5.1-timidity-cfg.patch
Patch6:         audacious-plugins-1.5.1-amidi-symbol.patch
Patch7:         audacious-plugins-1.5.1-neon-reader-error-crash.patch
Patch8:         audacious-plugins-1.5.1-sndfile-cleanup.patch
Patch9:         audacious-plugins-1.5.1-pulseaudio-volume.patch
Patch10:        audacious-plugins-1.5.1-pulseaudio-volume-accuracy.patch
Patch11:        audacious-plugins-1.5.1-sndfile-playfix.patch
Patch12:        audacious-plugins-1.5.1-modplug.patch
Patch13:        audacious-plugins-1.5.1-musepack.patch
Patch14:        audacious-plugins-1.5.1-neon.patch
Patch15:        audacious-plugins-1.5.1-jack.patch

# alsa-ng plugin from 2.1 devel up to 2.2 alpha1
Patch50: audacious-plugins-1.5.1-alsa-ng.patch
Patch51: audacious-plugins-1.5.1-alsaplug-id.patch
Patch52: audacious-plugins-1.5.1-mixer-not-ready.patch
# fight snd_pcm_writei underruns
Patch53: audacious-plugins-1.5.1-underruns.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  audacious-devel >= %{aud_ver}, esound-devel >= 0.2, libvorbis-devel >= 1.0
BuildRequires:  zlib-devel, desktop-file-utils >= 0.9, alsa-lib-devel
BuildRequires:  libsidplay-devel, libnotify-devel
BuildRequires:  libmpcdec-devel, libmusicbrainz-devel
BuildRequires:  taglib-devel >= 1.4, libogg-devel >= 1.0, flac-devel >= 1.1.2
BuildRequires:  libvisual-devel >= 0.2, SDL-devel >= 1.2.9
BuildRequires:  gettext, libbinio-devel, curl-devel
BuildRequires:  arts-devel, libmodplug-devel, lirc-devel
BuildRequires:  jack-audio-connection-kit-devel, libsamplerate-devel
BuildRequires:  pulseaudio-libs-devel, fluidsynth-devel
BuildRequires:  wavpack-devel >= 4.31
BuildRequires:  libXcomposite-devel
BuildRequires:  libmtp-devel
BuildRequires:  libmowgli-devel >= 0.5.0
BuildRequires:  mcs-devel >= 0.6.0
BuildRequires:  libcdio-devel >= 0.70
BuildRequires:  libcddb-devel >= 1.2.1
BuildRequires:  libsndfile-devel

# experimental, disabled by default
BuildRequires:  neon-devel >= 0.25

Requires:       audacious >= %{aud_ver}

# last tagged f8-final
Obsoletes:      audacious-plugins-pulseaudio <= 1.3.5
Provides:       audacious-plugins-pulseaudio = %{version}

%description
Audacious is a media player that currently uses a skinned user interface
based on Winamp 2.x skins. It is based on ("forked off") BMP.

This package provides essential plugins for audio input, audio output and
visualization.


%package        jack
Summary:        Audacious output plugin for JACK sound service
Group:          Applications/Multimedia
Obsoletes:      audacious-jack <= 1.1.2

Requires:       audacious >= %{aud_ver}, audacious-plugins >= %{aud_ver}

%description    jack
This package provides an Audacious output plugin that uses the
JACK sound service.


%package        esd
Summary:        Audacious output plugin for esd sound service
Group:          Applications/Multimedia
Obsoletes:      audacious-esd <= 1.1.2

Requires:       audacious >= %{aud_ver}, audacious-plugins >= %{aud_ver}

%description    esd
This package provides an Audacious output plugin that uses the
ESD sound server.


%package        arts
Summary:        Audacious output plugin for KDE arts sound service
Group:          Applications/Multimedia
Obsoletes:      audacious-arts <= 1.1.2

Requires:       audacious >= %{aud_ver}, audacious-plugins >= %{aud_ver}

%description    arts
This package provides an Audacious output plugin that uses the
KDE arts sound server.


%package        amidi
Summary:        Audacious input plugin for amidi
Group:          Applications/Multimedia

Requires:       audacious >= %{aud_ver}, audacious-plugins >= %{aud_ver}

%description    amidi
This package provides an Audacious input plugin that uses the
amidi sound service.



%package        wavpack
Summary:        Audacious input plugin for wavpack
Group:          Applications/Multimedia

Requires:       audacious >= %{aud_ver}, audacious-plugins >= %{aud_ver}

%description    wavpack
This package provides an Audacious input plugin that reads WavPack
compressed files.



%package        metronome
Summary:        Audacious input plugin simulating a metronome
Group:          Applications/Multimedia

Requires:       audacious >= %{aud_ver}, audacious-plugins >= %{aud_ver}

%description    metronome
This package provides an Audacious input plugin that simulates
a metronome.



%package        vortex
Summary:        Audacious input plugin for vortex audio files
Group:          Applications/Multimedia

Requires:       audacious >= %{aud_ver}, audacious-plugins >= %{aud_ver}

%description    vortex
This package provides an Audacious input plugin that reads
vortex compressed files.



%prep
%setup -q -n audacious-plugins-fedora-%{version}

# Use libmtp 0.3
%patch3 -p1 -b .libmtp

# accept .oga files
%patch4 -p1 -b vorbis-oga

# look for timidity.cfg in /etc
%patch5 -p1 -b timidity-cfg

# fix missing symbols in amidi
%patch6 -p1 -b amidi-symbols

# Patch possible neon crash on buffer underrun
%patch7 -p1 -b neon-reader-error-crash

# pause and seek for libsndfile input plugin
%patch8 -p1 -b .sndfile-cleanup

%patch9 -p1 -b .pulseaudio-volume
%patch10 -p1 -b .pulseaudio-volume-accuracy

%patch11 -p1 -b .sndfile-playfix
%patch12 -p1 -b .modplug
%patch13 -p1 -b .musepack
%patch14 -p1 -b .neon
%patch15 -p1 -b .jack_free

%patch50 -p1 -b .alsa-ng
%patch51 -p1 -b .alsa-ng2
%patch52 -p1 -b .mixer-not-ready
%patch53 -p1 -b .underruns

sed -i '\,^.SILENT:,d' buildsys.mk.in

%build
%configure \
    --disable-rpath \
    --enable-chardet \
    --disable-dependency-tracking \
    --enable-amidiplug \
    --disable-amidiplug-dummy \
    --disable-sse2 \
    --disable-rootvis \
    --disable-projectm \
    --enable-neon

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT INSTALL="install -p"
%find_lang %{name}

desktop-file-install --vendor fedora \
    --dir $RPM_BUILD_ROOT%{_datadir}/applications   \
    %{SOURCE1}

%clean
rm -rf $RPM_BUILD_ROOT


%post
update-desktop-database &> /dev/null || :


%postun
update-desktop-database &> /dev/null || :


%files -f %{name}.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS
%{_libdir}/audacious/Input/
%{_libdir}/audacious/Output/
%{_libdir}/audacious/Container/
%{_libdir}/audacious/Effect/
%{_libdir}/audacious/General/
%{_libdir}/audacious/Visualization/
%{_libdir}/audacious/Transport/
%exclude %{_libdir}/audacious/Input/amidi-plug.so
%exclude %{_libdir}/audacious/Input/amidi-plug/
%exclude %{_libdir}/audacious/Input/wavpack.so
%exclude %{_libdir}/audacious/Input/metronom.so
%exclude %{_libdir}/audacious/Input/vtx.so
%exclude %{_libdir}/audacious/Output/jackout.so
%exclude %{_libdir}/audacious/Output/arts.so
%exclude %{_libdir}/audacious/Output/ESD.so
%{_datadir}/applications/fedora-audacious-plugins.desktop
%{_datadir}/audacious/images/audioscrobbler.png
%{_datadir}/audacious/images/audioscrobbler_badge.png
%{_datadir}/audacious/paranormal/

%files jack
%defattr(-,root,root,-)
%{_libdir}/audacious/Output/jackout.so

%files arts
%defattr(-,root,root,-)
%{_bindir}/audacious-arts-helper
%{_libdir}/audacious/Output/arts.so

%files esd
%defattr(-,root,root,-)
%{_libdir}/audacious/Output/ESD.so

%files amidi
%defattr(-,root,root,-)
%{_libdir}/audacious/Input/amidi-plug.so
%{_libdir}/audacious/Input/amidi-plug/

%files wavpack
%defattr(-,root,root,-)
%{_libdir}/audacious/Input/wavpack.so

%files metronome
%defattr(-,root,root,-)
%{_libdir}/audacious/Input/metronom.so

%files vortex
%defattr(-,root,root,-)
%{_libdir}/audacious/Input/vtx.so


%changelog
* Thu Dec  3 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-19
- Fix truncated track name for streaming mp3 in neon.c (#543050).
- Merge jack_free redeclaration fix.

* Tue Nov 17 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-18
- Corrupt musepack files were able to crash Audacious.

* Tue Nov 17 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-17
- More cleanup in musepack plugin.

* Fri Nov 13 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-16
- Patch musepack plugin to remove old cruft and fix playback.
- Patch modplug plugin to remove old cruft and fix playback.

* Wed Oct 28 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-15
- Remove decode_thread from sndfile plugin to fix playback.

* Wed Oct 21 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-14
- Set buffer_time_min in underruns patch. Depend on default buffer size.

* Wed Oct 21 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-13
- Patch pulseaudio plugin to not suffer from precision loss when
  calculating the volume level to save.

* Mon Oct 19 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-12
- Patch pulseaudio plugin to not get confused by volume values passed
  in via callback.

* Sat Sep 19 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-11
- Patch alsa-ng plugin with some buffer prefilling to fight underruns.
- Merge minor changes from 2.2 alpha1 alsa-ng plugin.

* Thu Jul  2 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-10
- Prevent alsalib mixer crash if mixer isn't ready.

* Mon Jun 29 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-9
- Use old "ALSA" plugin id for config file.
- Keep old mixer level even if mixer isn't ready.

* Mon Jun 29 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-8
- Replace old ALSA output plugin and related patches with the
  "alsa-ng" code from Audacious 2.1 development. This is supposed to
  get rid of old cruft and mutex-locking overhead that cause performance
  regression in 1.5.1-6.

* Fri Jun  5 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-7
- Remove unapplied patches and verify that they have been merged.
- Multiple different licenses are used for the individual plugins.
- Move amidi-plug directory to amidi subpackage.

* Thu Jun  4 2009 Michael Schwendt <mschwendt@fedoraproject.org> - 1.5.1-6
- Apply ALSA driver patches by Hans de Goede (#499942).
- Minor spec updates.
- Update scriptlets in accordance with guidelines.
- Build with libsndfile plugin for advanced formats in WAV and
  patch it for pause and seek (also fixes #501007).

* Wed May 06 2009 Ralf Ertzinger <ralf@skytale.net> 1.5.1-5
- Fix possible crash on neon buffer underrun (BZ#496413)

* Fri May 01 2009 Ralf Ertzinger <ralf@skytale.net> 1.5.1-4
- Accept .oga files (BZ#479120)
- Look for timitidy.cfg in /etc (BZ#450933)
- Fix missing symbols in amidi-plugin (BZ#478557)
- Include CD-audio plugin (BZ#442921)

* Mon Feb 23 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Sep 06 2008 Ralf Ertzinger <ralf@skytale.net> 1.5.1-2
- Incorporate libmtp patch by Linus Walleij (BZ#459293)

* Sun Jun 08 2008 Ralf Ertzinger <ralf@skytale.net> 1.5.1-1
- Update to 1.5.1

* Mon Feb 11 2008 Ralf Ertzinger <ralf@skytale.net> 1.4.5-1
- Update to 1.4.5

* Fri Jan 02 2008 Ralf Ertzinger <ralf@skytale.net> 1.4.4-2
- Fix compilation with GCC 4.3

* Wed Jan 02 2008 Ralf Ertzinger <ralf@skytale.net> 1.4.4-1
- Update to 1.4.4

* Mon Dec 31 2007 Ralf Ertzinger <ralf@skytale.net> 1.4.3.2-1
- Update to 1.4.3.2

* Sun Dec 29 2007 Ralf Ertzinger <ralf@skytale.net> 1.4.3.1-1
- Update to 1.4.3.1

* Sat Dec 29 2007 Ralf Ertzinger <ralf@skytale.net> 1.4.3-1
- Update to 1.4.3

* Thu Dec 04 2007 Ralf Ertzinger <ralf@skytale.net> 1.4.2-1
- Update to 1.4.2

* Thu Nov 22 2007 Ralf Ertzinger <ralf@skytale.net> 1.4.1-3
- Fix some locking issues in the neon (HTTP/HTTPS stream) plugin

* Mon Nov 19 2007 Ralf Ertzinger <ralf@skytale.net> 1.4.1-1
- Update to 1.4.1

* Mon Oct 15 2007 Lubomir Kundrak <lkundrak@redhat.com 1.3.5-3
- Change BuildReq pulseaudio-devel to pulseaudio-libs-devel
- Fix the License tag

* Fri Aug 3 2007 Ralf Ertzinger <ralf@skytale.net> 1.3.5-2
- Rebuild for clean upgrade path

* Sat Jun 9 2007 Ralf Ertzinger <ralf@skytale.net> 1.3.5-1.fc8
- Update to 1.3.5

* Sat May 26 2007 Ralf Ertzinger <ralf@skytale.net> 1.3.4-2.fc8
- Bump tag for rebuild

* Wed May 16 2007 Ralf Ertzinger <ralf@skytale.net> 1.3.4-1.fc7
- Update to 1.3.4

* Sun Apr 22 2007 Ralf Ertzinger <ralf@skytale.net> 1.3.3-2.fc7
- Introduce aud_ver variable into specfile

* Fri Apr 20 2007 Ralf Ertzinger <ralf@skytale.net> 1.3.3-1.fc7
- Update to 1.3.3

* Sat Apr 07 2007 Ralf Ertzinger <ralf@skytale.net> 1.3.2-1.fc7
- Update to 1.3.2

* Fri Apr 06 2007 Ralf Ertzinger <ralf@skytale.net> 1.3.1-2.fc7
- Own %%{_datadir}/audacious

* Mon Apr 02 2007 Ralf Ertzinger <ralf@skytale.net> 1.3.1-1.fc7
- Update to 1.3.1

* Sun Feb 18 2007 Ralf Ertzinger <ralf@skytale.net> 1.2.5-6.fc7
- Rebuild against new FLAC libraries (for real, this time)

* Thu Feb 15 2007 Ralf Ertzinger <ralf@skytale.net> 1.2.5-5.fc7
- Rebuild against new FLAC libraries

* Mon Jan 15 2007 Ralf Ertzinger <ralf@skytale.net> 1.2.5-4.fc7
- Fix typo in BuildRequires

* Sat Dec 16 2006 Ralf Ertzinger <ralf@skytale.net> 1.2.5-3.fc7
- Rebuild for new wavpack

* Sun Dec 03 2006 Ralf Ertzinger <ralf@skytale.net> 1.2.5-2.fc7
- Disable sndfile, which causes a non-pausable wav plugin to
  be built

* Thu Nov 30 2006 Ralf Ertzinger <ralf@skytale.net> 1.2.5-1.fc7
- Update to 1.2.5
- Add audacious-plugins-wavpack for WavPack input plugin
- Drop cddb patch, included upstream

* Sun Nov 26 2006 Ralf Ertzinger <ralf@skytale.net> 1.2.2-1.fc7
- Initial RPM build for FE
